# Google Data APIs Client Library (1.43.0)

## com.google.gdata.data.spreadsheet
Class Data

    java.lang.Object
      com.google.gdata.data.AbstractExtension
          com.google.gdata.data.ExtensionPoint
              com.google.gdata.data.spreadsheet.Data

All Implemented Interfaces:
  Extension

    public class Data

extends ExtensionPoint

Describes a data region of a table.

Nested Class Summary
`static class` `Data.InsertionMode` Insertion mode.

Nested classes/interfaces inherited from class com.google.gdata.data.ExtensionPoint
`ExtensionPoint.CumulativeBlobHandler, ExtensionPoint.ExtensionHandler`

Nested classes/interfaces inherited from class com.google.gdata.data.AbstractExtension
`AbstractExtension.AttributesHandler`

Field Summary

Fields inherited from class com.google.gdata.data.ExtensionPoint
`xmlBlob`

Fields inherited from class com.google.gdata.data.AbstractExtension
`localName, namespace`

Constructor Summary
`Data()` Default mutable constructor.
`Data(Data.InsertionMode insertionMode, java.lang.Integer numberOfRows, java.lang.Integer startIndex)` Immutable constructor.

Method Summary
`void` `addColumn(Column column)` Adds a new column.
`protected void` `consumeAttributes(AttributeHelper helper)` Consumes attributes from the attribute helper.
`void` `declareExtensions(ExtensionProfile extProfile)` Declares the set of expected Extension types for an ExtensionPoint within the target extension profile.
`java.util.List<Column>` `getColumns()` Returns the columns.
`static ExtensionDescription` `getDefaultDescription(boolean required, boolean repeatable)` Returns the extension description, specifying whether it is required, and whether it is repeatable.
`Data.InsertionMode` `getInsertionMode()` Returns the insertion mode.
`java.lang.Integer` `getNumberOfRows()` Returns the number of rows in the data section.
`java.lang.Integer` `getStartIndex()` Returns the index of the first row of the data section (inclusive).
`boolean` `hasColumns()` Returns whether it has the columns.
`boolean` `hasInsertionMode()` Returns whether it has the insertion mode.
`boolean` `hasNumberOfRows()` Returns whether it has the number of rows in the data section.
`boolean` `hasStartIndex()` Returns whether it has the index of the first row of the data section (inclusive).
`protected void` `putAttributes(AttributeGenerator generator)` Puts attributes into the attribute generator.
`void` `setInsertionMode(Data.InsertionMode insertionMode)` Sets the insertion mode.
`void` `setNumberOfRows(java.lang.Integer numberOfRows)` Sets the number of rows in the data section.
`void` `setStartIndex(java.lang.Integer startIndex)` Sets the index of the first row of the data section (inclusive).
`java.lang.String` `toString()`
`protected void` `validate()` Checks the attributes to see if there are any problems.

Methods inherited from class com.google.gdata.data.ExtensionPoint

`addExtension, addExtension, addRepeatingExtension, addRepeatingExtension, checkRequiredExtensions, createExtensionInstance, generate, generateCumulativeXmlBlob, generateExtensions, generateStartElement, getExtension, getExtensionDescription, getExtensionHandler, getExtensions, getHandler, getManifest, getRepeatingExtension, getRepeatingExtensions, getXmlBlob, hasExtension, hasRepeatingExtension, initializeArbitraryXml, parseCumulativeXmlBlob, removeExtension, removeExtension, removeRepeatingExtension, setExtension, setXmlBlob, visit, visitChild, visitChildren`

Methods inherited from class com.google.gdata.data.AbstractExtension
`disableStrictValidation, enableStrictValidation, eq, generate, generateAttributes, getExtensionLocalName, getExtensionNamespace, isImmutable, isStrictValidation, sameClassAs, setImmutable, throwExceptionForMissingAttribute, throwExceptionIfImmutable`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Data

    public Data()

  Default mutable constructor.

### Data

    public Data(Data.InsertionMode insertionMode,
                java.lang.Integer numberOfRows,
                java.lang.Integer startIndex)

  Immutable constructor.

  Parameters:
    `insertionMode` - insertion mode.
    `numberOfRows` - number of rows in the data section.
    `startIndex` - index of the first row of the data section (inclusive).

Method Detail

### declareExtensions

    public void declareExtensions(ExtensionProfile extProfile)

  Description copied from class: `ExtensionPoint`
  Declares the set of expected Extension types for an ExtensionPoint within the target extension profile. The base implementation does not declare any extensions, but can be overridden by specific types of ExtensionPoints that always contain a well-defined set of extensions.

  Overrides:
    `declareExtensions` in class `ExtensionPoint`
  Parameters:
    `extProfile` - the ExtensionProfile to initialize.

### getColumns

    public java.util.List<Column> getColumns()

  Returns the columns.

  Returns:
    columns

### addColumn

    public void addColumn(Column column)

  Adds a new column.

  Parameters:
    `column` - column

### hasColumns

    public boolean hasColumns()

  Returns whether it has the columns.

  Returns:
    whether it has the columns

### getInsertionMode

    public Data.InsertionMode getInsertionMode()

  Returns the insertion mode.

  Returns:
    insertion mode

### setInsertionMode

    public void setInsertionMode(Data.InsertionMode insertionMode)

  Sets the insertion mode.

  Parameters:
    `insertionMode` - insertion mode or `null` to reset

### hasInsertionMode

    public boolean hasInsertionMode()

  Returns whether it has the insertion mode.

  Returns:
    whether it has the insertion mode

### getNumberOfRows

    public java.lang.Integer getNumberOfRows()

  Returns the number of rows in the data section.

  Returns:
    number of rows in the data section

### setNumberOfRows

    public void setNumberOfRows(java.lang.Integer numberOfRows)

  Sets the number of rows in the data section.

  Parameters:
    `numberOfRows` - number of rows in the data section or `null` to reset

### hasNumberOfRows

    public boolean hasNumberOfRows()

  Returns whether it has the number of rows in the data section.

  Returns:
    whether it has the number of rows in the data section

### getStartIndex

    public java.lang.Integer getStartIndex()

  Returns the index of the first row of the data section (inclusive).

  Returns:
    index of the first row of the data section (inclusive)

### setStartIndex

    public void setStartIndex(java.lang.Integer startIndex)

  Sets the index of the first row of the data section (inclusive).

  Parameters:
    `startIndex` - index of the first row of the data section (inclusive) or `null` to reset

### hasStartIndex

    public boolean hasStartIndex()

  Returns whether it has the index of the first row of the data section (inclusive).

  Returns:
    whether it has the index of the first row of the data section (inclusive)

### validate

    protected void validate()

  Description copied from class: `AbstractExtension`
  Checks the attributes to see if there are any problems. Default implementation does nothing, though generally this is discouraged unless there really are no restrictions.

  Overrides:
    `validate` in class `AbstractExtension`

### getDefaultDescription

    public static ExtensionDescription getDefaultDescription(boolean required,
                                                             boolean repeatable)

  Returns the extension description, specifying whether it is required, and whether it is repeatable.

  Parameters:
    `required` - whether it is required
    `repeatable` - whether it is repeatable
  Returns:
    extension description

### putAttributes

    protected void putAttributes(AttributeGenerator generator)

  Description copied from class: `AbstractExtension`
  Puts attributes into the attribute generator. Called from `AbstractExtension.generate(XmlWriter,ExtensionProfile)`. Default implementation does nothing, though generally this is discouraged unless there really are no attributes.

  Overrides:
    `putAttributes` in class `AbstractExtension`
  Parameters:
    `generator` - attribute generator

### consumeAttributes

    protected void consumeAttributes(AttributeHelper helper)
                              throws ParseException

  Description copied from class: `AbstractExtension`
  Consumes attributes from the attribute helper. May also use `AttributeHelper.consumeContent(boolean)` to consume the element's text content. Called from `AbstractExtension.getHandler(com.google.gdata.data.ExtensionProfile, java.lang.String, java.lang.String, org.xml.sax.Attributes)`. Default implementation does nothing, though generally this is discouraged unless there really are no attributes.

  Overrides:
    `consumeAttributes` in class `AbstractExtension`
  Parameters:
    `helper` - attribute helper
  Throws:
    `ParseException` - any parsing exception

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`